/**HEADER********************************************************************
* 
* Copyright (c) 2008 Freescale Semiconductor;
* All Rights Reserved                       
*
*************************************************************************** 
*
* THIS SOFTWARE IS PROVIDED BY FREESCALE "AS IS" AND ANY EXPRESSED OR 
* IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  
* IN NO EVENT SHALL FREESCALE OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
* SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
* STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
* IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
* THE POSSIBILITY OF SUCH DAMAGE.
*
**************************************************************************
*
* $FileName: httpd.h$
* $Version : 3.8.21.0$
* $Date    : Aug-31-2012$
*
* Comments:
*
*   Header for HTTPD.
*
*END************************************************************************/

#ifndef HTTPD_H_
#define HTTPD_H_

#include <rtcs.h>
#include "httpd_types.h"
#include "httpd_supp.h"

#define HTTPD_OK 0
#define HTTPD_BIND_FAIL 1 
#define HTTPD_LISTEN_FAIL 2
#define HTTPD_ERR 3
#define HTTPD_CREATE_FAIL 4
#define HTTPD_BAD_FAMILY 5
#define HTTPD_SOCKOPT_FAIL 6

/** Initialize HTTP server.
 * \param server < pointer to server data structure
 * \return server handle
 */
uint_32 httpd_init(HTTPD_PARAMS_STRUCT *params);

/** Release HTTP server.
 * \param server < server handle
 * \return 0 when success
 */
uint_32 httpd_release(uint_32 server_h);

#endif /* HTTP_H_ */
